//Build Game Processor "Asterisk's Adventure" game
architecture snes.cpu

//Seek HiROM Address (512KB)
macro seekAddr(n) {
  origin ({n} & $07FFFF)
  base {n}
}

output "./gpc4m_patched.sfc", create
seekAddr(0)
fill $80000,$00	//Extend to 512KB
origin 0
insert "./gpc4m_hirom.sfc"

seekAddr($008032)
	//FIX CORRUPTION based on similar code found elsewhere in the ROM
	//This is the only place where I could find obvious bitrot of sorts.
	sta.w $212C
	sta.w $212D
	jsr $83F3
-;	rep #$20
	lda.w $0426
	and.w #$1000
	bne +
	jmp -
+;	sep #$20

	//Modification: Initialize all variables. I can't seem to find anything that suggests to initialize these values early in execution.
	//It only does it at the end for some reason, after the Game Over.
	jsr $9592
	nop; nop

seekAddr($0095D6)
	//Fix collision by initializing these values as 16-bit instead of 8-bit
	//because of a mistake in the collision detection code treating these values as 16-bit instead
	//found at 008AA4, 008ADC, 008B17
	//Literally everywhere else, these values are treated as 8-bit.
	stz.b $2F
	stz.b $31
	sep #$20
	stz.b $1A
	stz.b $23
