//Build Game Processor "Asterisk's Adventure" game
architecture snes.cpu

//Seek HiROM Address (512KB)
macro seekAddr(n) {
  origin ({n} & $07FFFF)
  base {n}
}

output "./gpc4m_patchedaudio.sfc", create
seekAddr(0)
fill $80000,$00	//Extend to 512KB
origin 0
insert "./gpc4m_hirom.sfc"

seekAddr($008032)
	//FIX CORRUPTION based on similar code found elsewhere in the ROM
	//This is the only place where I could find obvious bitrot of sorts.
	sta.w $212C
	sta.w $212D
	jsr $83F3
-;	rep #$20
	lda.w $0426
	and.w #$1000
	bne +
	jmp -
+;	sep #$20

	//Modification: Initialize all variables. I can't seem to find anything that suggests to initialize these values early in execution.
	//It only does it at the end for some reason, after the Game Over.
	jsr patch_start
	nop; nop

seekAddr($0095D6)
	//Fix collision by initializing these values as 16-bit instead of 8-bit
	//because of a mistake in the collision detection code treating these values as 16-bit instead
	//found at 008AA4, 008ADC, 008B17
	//Literally everywhere else, these values are treated as 8-bit.
	stz.b $2F
	stz.b $31
	sep #$20
	stz.b $1A
	stz.b $23

//008E02 = Upload Sound Driver
//008E1B = Start Music
//008E31 = Manage Sound Effects based on Joypad
//009974 = Wait a frame

seekAddr($00801B)
	//Change Init Process
	jsr patch_init
	nop;nop;nop

seekAddr($00807C)
	//Gameplay Loop
	jsr $9974	//Wait a frame
	jsr $854B	//Gameplay Loop
	lda.b $09
	bne +
	jsr $8E31	//Manage Sound Effects
+;	nop

seekAddr($00F000)
patch_init:
	jsr $80E4	//Init PPU
	jsr $8182	//Init 5A22
	phd
	php
	rep #$20
	lda.w #$016F
	tcd
	jsr $8E02	//Upload Sound Driver
	plp
	pld
	rts
patch_start:
	jsr $9592	//Init Vars
	//jsr $8E1B	//Start Music
	rts
patch_audio_flagbsfix:
	//they forgot to put rep #$20...
	rep #$20
	lda.w $0426
	and.w #$0040
	rts
patch_audio_reset:
	php
	sep #$20
	lda.b #$FF
	sta.w $2140
	plp
	rts

seekAddr($008E70)
	jsr patch_audio_flagbsfix
	nop; nop

seekAddr($0080C0)
	jsr patch_audio_reset
